/**
 * @name eslint-plugin-row-num
 * @fileoverview ESLint plugin to update row numbers on each console.log
 * @version 4.0.19
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/eslint-plugin-row-num/}
 */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
// ../../node_modules/rfdc/index.js
var require_rfdc = __commonJS({
  "../../node_modules/rfdc/index.js"(exports, module2) {
    "use strict";
    module2.exports = rfdc;
    function copyBuffer(cur) {
      if (cur instanceof Buffer) {
        return Buffer.from(cur);
      }
      return new cur.constructor(cur.buffer.slice(), cur.byteOffset, cur.length);
    }
    function rfdc(opts) {
      opts = opts || {};
      if (opts.circles)
        return rfdcCircles(opts);
      return opts.proto ? cloneProto : clone;
      function cloneArray(a, fn) {
        var keys = Object.keys(a);
        var a2 = new Array(keys.length);
        for (var i = 0; i < keys.length; i++) {
          var k2 = keys[i];
          var cur = a[k2];
          if (typeof cur !== "object" || cur === null) {
            a2[k2] = cur;
          } else if (cur instanceof Date) {
            a2[k2] = new Date(cur);
          } else if (ArrayBuffer.isView(cur)) {
            a2[k2] = copyBuffer(cur);
          } else {
            a2[k2] = fn(cur);
          }
        }
        return a2;
      }
      function clone(o) {
        if (typeof o !== "object" || o === null)
          return o;
        if (o instanceof Date)
          return new Date(o);
        if (Array.isArray(o))
          return cloneArray(o, clone);
        if (o instanceof Map)
          return new Map(cloneArray(Array.from(o), clone));
        if (o instanceof Set)
          return new Set(cloneArray(Array.from(o), clone));
        var o2 = {};
        for (var k2 in o) {
          if (Object.hasOwnProperty.call(o, k2) === false)
            continue;
          var cur = o[k2];
          if (typeof cur !== "object" || cur === null) {
            o2[k2] = cur;
          } else if (cur instanceof Date) {
            o2[k2] = new Date(cur);
          } else if (cur instanceof Map) {
            o2[k2] = new Map(cloneArray(Array.from(cur), clone));
          } else if (cur instanceof Set) {
            o2[k2] = new Set(cloneArray(Array.from(cur), clone));
          } else if (ArrayBuffer.isView(cur)) {
            o2[k2] = copyBuffer(cur);
          } else {
            o2[k2] = clone(cur);
          }
        }
        return o2;
      }
      function cloneProto(o) {
        if (typeof o !== "object" || o === null)
          return o;
        if (o instanceof Date)
          return new Date(o);
        if (Array.isArray(o))
          return cloneArray(o, cloneProto);
        if (o instanceof Map)
          return new Map(cloneArray(Array.from(o), cloneProto));
        if (o instanceof Set)
          return new Set(cloneArray(Array.from(o), cloneProto));
        var o2 = {};
        for (var k2 in o) {
          var cur = o[k2];
          if (typeof cur !== "object" || cur === null) {
            o2[k2] = cur;
          } else if (cur instanceof Date) {
            o2[k2] = new Date(cur);
          } else if (cur instanceof Map) {
            o2[k2] = new Map(cloneArray(Array.from(cur), cloneProto));
          } else if (cur instanceof Set) {
            o2[k2] = new Set(cloneArray(Array.from(cur), cloneProto));
          } else if (ArrayBuffer.isView(cur)) {
            o2[k2] = copyBuffer(cur);
          } else {
            o2[k2] = cloneProto(cur);
          }
        }
        return o2;
      }
    }
    function rfdcCircles(opts) {
      var refs = [];
      var refsNew = [];
      return opts.proto ? cloneProto : clone;
      function cloneArray(a, fn) {
        var keys = Object.keys(a);
        var a2 = new Array(keys.length);
        for (var i = 0; i < keys.length; i++) {
          var k2 = keys[i];
          var cur = a[k2];
          if (typeof cur !== "object" || cur === null) {
            a2[k2] = cur;
          } else if (cur instanceof Date) {
            a2[k2] = new Date(cur);
          } else if (ArrayBuffer.isView(cur)) {
            a2[k2] = copyBuffer(cur);
          } else {
            var index = refs.indexOf(cur);
            if (index !== -1) {
              a2[k2] = refsNew[index];
            } else {
              a2[k2] = fn(cur);
            }
          }
        }
        return a2;
      }
      function clone(o) {
        if (typeof o !== "object" || o === null)
          return o;
        if (o instanceof Date)
          return new Date(o);
        if (Array.isArray(o))
          return cloneArray(o, clone);
        if (o instanceof Map)
          return new Map(cloneArray(Array.from(o), clone));
        if (o instanceof Set)
          return new Set(cloneArray(Array.from(o), clone));
        var o2 = {};
        refs.push(o);
        refsNew.push(o2);
        for (var k2 in o) {
          if (Object.hasOwnProperty.call(o, k2) === false)
            continue;
          var cur = o[k2];
          if (typeof cur !== "object" || cur === null) {
            o2[k2] = cur;
          } else if (cur instanceof Date) {
            o2[k2] = new Date(cur);
          } else if (cur instanceof Map) {
            o2[k2] = new Map(cloneArray(Array.from(cur), clone));
          } else if (cur instanceof Set) {
            o2[k2] = new Set(cloneArray(Array.from(cur), clone));
          } else if (ArrayBuffer.isView(cur)) {
            o2[k2] = copyBuffer(cur);
          } else {
            var i = refs.indexOf(cur);
            if (i !== -1) {
              o2[k2] = refsNew[i];
            } else {
              o2[k2] = clone(cur);
            }
          }
        }
        refs.pop();
        refsNew.pop();
        return o2;
      }
      function cloneProto(o) {
        if (typeof o !== "object" || o === null)
          return o;
        if (o instanceof Date)
          return new Date(o);
        if (Array.isArray(o))
          return cloneArray(o, cloneProto);
        if (o instanceof Map)
          return new Map(cloneArray(Array.from(o), cloneProto));
        if (o instanceof Set)
          return new Set(cloneArray(Array.from(o), cloneProto));
        var o2 = {};
        refs.push(o);
        refsNew.push(o2);
        for (var k2 in o) {
          var cur = o[k2];
          if (typeof cur !== "object" || cur === null) {
            o2[k2] = cur;
          } else if (cur instanceof Date) {
            o2[k2] = new Date(cur);
          } else if (cur instanceof Map) {
            o2[k2] = new Map(cloneArray(Array.from(cur), cloneProto));
          } else if (cur instanceof Set) {
            o2[k2] = new Set(cloneArray(Array.from(cur), cloneProto));
          } else if (ArrayBuffer.isView(cur)) {
            o2[k2] = copyBuffer(cur);
          } else {
            var i = refs.indexOf(cur);
            if (i !== -1) {
              o2[k2] = refsNew[i];
            } else {
              o2[k2] = cloneProto(cur);
            }
          }
        }
        refs.pop();
        refsNew.pop();
        return o2;
      }
    }
  }
});
// src/main.ts
var main_exports = {};
__export(main_exports, {
  default: () => main_default
});
// ../string-collapse-leading-whitespace/dist/string-collapse-leading-whitespace.esm.js
function D(n, u2 = 1) {
  let $2 = "\xA0";
  function g2(e) {
    return Array.from(e).reverse().join("");
  }
  function p2(e, s, r2) {
    let t = r2 ? `
` : "\r", i = r2 ? "\r" : `
`;
    if (!e)
      return e;
    let m = 0, c = 0, o = "";
    for (let l2 = 0, f2 = e.length; l2 < f2; l2++)
      (e[l2] === t || e[l2] === i && e[l2 - 1] !== t) && c++, `\r
`.includes(e[l2]) || e[l2] === $2 ? (m = 0, e[l2] === $2 ? o += e[l2] : e[l2] === t ? c <= s && (o += e[l2], e[l2 + 1] === i && (o += e[l2 + 1], l2++)) : e[l2] === i && e?.[l2 - 1] !== t && c <= s && (o += e[l2])) : (m++, !e[l2 + 1] && !c && (o += " "));
    return o;
  }
  if (typeof n == "string" && n.length) {
    let e = 1;
    typeof +u2 == "number" && Number.isInteger(+u2) && +u2 >= 0 && (e = +u2);
    let s = "", r2 = "";
    if (!n.trim())
      s = n;
    else if (!n[0].trim()) {
      for (let t = 0, i = n.length; t < i; t++)
        if (n[t].trim()) {
          s = n.slice(0, t);
          break;
        }
    }
    if (n.trim() && (n.slice(-1).trim() === "" || n.slice(-1) === $2)) {
      for (let t = n.length; t--; )
        if (n[t].trim()) {
          r2 = n.slice(t + 1);
          break;
        }
    }
    return `${p2(s, e, false)}${n.trim()}${g2(p2(g2(r2), e, true))}`;
  }
  return n;
}
// ../codsen-utils/dist/codsen-utils.esm.js
var import_rfdc = __toESM(require_rfdc(), 1);
var l = (0, import_rfdc.default)();
function u(t) {
  if (t == null || typeof t != "object")
    return false;
  let e = Object.getPrototypeOf(t);
  return e !== null && e !== Object.prototype && Object.getPrototypeOf(e) !== null ? false : !(Symbol.iterator in t) && !(Symbol.toStringTag in t);
}
function r(t) {
  return typeof t == "string";
}
function q(t) {
  return Number.isSafeInteger(t) && t >= 0;
}
function G(t) {
  return t != null;
}
function v(t, e) {
  return u(t) && r(e) && e in t;
}
// ../ranges-sort/dist/ranges-sort.esm.js
var d = { strictlyTwoElementsInRangeArrays: false, progressFn: null };
function g(t, u2) {
  if (!Array.isArray(t) || !t.length)
    return t;
  let n = { ...d, ...u2 }, s, o;
  if (n.strictlyTwoElementsInRangeArrays && !t.every((e, r2) => !Array.isArray(e) || e.length !== 2 ? (s = r2, o = e.length, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(t[s], null, 4)}) has not two but ${o} elements!`);
  if (!t.every((e, r2) => !Array.isArray(e) || !Number.isInteger(e[0]) || e[0] < 0 || !Number.isInteger(e[1]) || e[1] < 0 ? (s = r2, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(t[s], null, 4)}) does not consist of only natural numbers!`);
  let p2 = t.length ** 2, i = 0;
  return Array.from(t).sort((e, r2) => (n.progressFn && (i += 1, n.progressFn(Math.floor(i * 100 / p2))), e[0] === r2[0] ? e[1] < r2[1] ? -1 : e[1] > r2[1] ? 1 : 0 : e[0] < r2[0] ? -1 : 1));
}
// ../ranges-push/dist/ranges-push.esm.js
var f = { mergeType: 1, progressFn: null, joinRangesThatTouchEdges: true };
function $(p2, t) {
  function r2(e) {
    return !!e && typeof e == "object" && !Array.isArray(e);
  }
  if (!Array.isArray(p2) || !p2.length)
    return null;
  let s;
  if (t)
    if (r2(t)) {
      if (s = { ...f, ...t }, s.progressFn && r2(s.progressFn) && !Object.keys(s.progressFn).length)
        s.progressFn = null;
      else if (s.progressFn && typeof s.progressFn != "function")
        throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn, null, 4)}`);
      if (![1, 2, "1", "2"].includes(s.mergeType))
        throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType, null, 4)}`);
      if (typeof s.joinRangesThatTouchEdges != "boolean")
        throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges, null, 4)}`);
    } else
      throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(t, null, 4)} (type ${typeof t})`);
  else
    s = { ...f };
  let i = p2.filter((e) => Array.isArray(e)).map((e) => [...e]).filter((e) => e[2] !== void 0 || e[0] !== e[1]), n, o, l2;
  s.progressFn ? n = g(i, { progressFn: (e) => {
    l2 = Math.floor(e / 5), l2 !== o && (o = l2, s.progressFn(l2));
  } }) : n = g(i);
  let h = n.length - 1;
  for (let e = h; e > 0; e--)
    s.progressFn && (l2 = Math.floor((1 - e / h) * 78) + 21, l2 !== o && l2 > o && (o = l2, s.progressFn(l2))), (n[e][0] <= n[e - 1][0] || !s.joinRangesThatTouchEdges && n[e][0] < n[e - 1][1] || s.joinRangesThatTouchEdges && n[e][0] <= n[e - 1][1]) && (n[e - 1][0] = Math.min(n[e][0], n[e - 1][0]), n[e - 1][1] = Math.max(n[e][1], n[e - 1][1]), n[e][2] !== void 0 && (n[e - 1][0] >= n[e][0] || n[e - 1][1] <= n[e][1]) && n[e - 1][2] !== null && (n[e][2] === null && n[e - 1][2] !== null ? n[e - 1][2] = null : n[e - 1][2] != null ? +s.mergeType == 2 && n[e - 1][0] === n[e][0] ? n[e - 1][2] = n[e][2] : n[e - 1][2] += n[e][2] : n[e - 1][2] = n[e][2]), n.splice(e, 1), e = n.length);
  return n.length ? n : null;
}
var R = { limitToBeAddedWhitespace: false, limitLinebreaksCount: 1, mergeType: 1 };
var y = class {
  constructor(t) {
    let r2 = { ...R, ...t };
    if (r2.mergeType && r2.mergeType !== 1 && r2.mergeType !== 2)
      if (r(r2.mergeType) && r2.mergeType.trim() === "1")
        r2.mergeType = 1;
      else if (r(r2.mergeType) && r2.mergeType.trim() === "2")
        r2.mergeType = 2;
      else
        throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof r2.mergeType}", equal to ${JSON.stringify(r2.mergeType, null, 4)}`);
    this.opts = r2, this.ranges = [];
  }
  ranges;
  opts;
  add(t, r2, s) {
    if (t == null && r2 == null)
      return;
    if (G(t) && !G(r2)) {
      if (Array.isArray(t)) {
        if (t.length) {
          if (t.some((o) => Array.isArray(o))) {
            t.forEach((o) => {
              Array.isArray(o) && this.add(...o);
            });
            return;
          }
          t.length && q(+t[0]) && q(+t[1]) && this.add(...t);
        }
        return;
      }
      throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(t, null, 0)}) but second-one, "to" is not (${JSON.stringify(r2, null, 0)})`);
    } else if (!G(t) && G(r2))
      throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(r2, null, 0)}) but first-one, "from" is not (${JSON.stringify(t, null, 0)})`);
    let i = +t, n = +r2;
    if (q(s) && (s = String(s)), q(i) && q(n)) {
      if (G(s) && !r(s) && !q(s))
        throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof s}, equal to:
${JSON.stringify(s, null, 4)}`);
      if (G(this.ranges) && Array.isArray(this.last()) && i === this.last()[1]) {
        if (this.last()[1] = n, this.last()[2], this.last()[2] !== null && G(s)) {
          let o = this.last()[2] && this.last()[2].length && (!this.opts?.mergeType || this.opts.mergeType === 1) ? `${this.last()[2]}${s}` : s;
          this.opts.limitToBeAddedWhitespace && (o = D(o, this.opts.limitLinebreaksCount)), r(o) && !o.length || (this.last()[2] = o);
        }
      } else {
        this.ranges || (this.ranges = []);
        let o = s !== void 0 && !(r(s) && !s.length) ? [i, n, s && this.opts.limitToBeAddedWhitespace ? D(s, this.opts.limitLinebreaksCount) : s] : [i, n];
        this.ranges.push(o);
      }
    } else
      throw q(i) && i >= 0 ? new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof n}" equal to: ${JSON.stringify(n, null, 4)}`) : new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof i}" equal to: ${JSON.stringify(i, null, 4)}`);
  }
  push(t, r2, s) {
    this.add(t, r2, s);
  }
  current() {
    return Array.isArray(this.ranges) && this.ranges.length ? (this.ranges = $(this.ranges, { mergeType: this.opts.mergeType }), this.ranges && this.opts.limitToBeAddedWhitespace ? this.ranges.map((t) => G(t[2]) ? [t[0], t[1], D(t[2], this.opts.limitLinebreaksCount)] : t) : this.ranges) : null;
  }
  wipe() {
    this.ranges = [];
  }
  replace(t) {
    if (Array.isArray(t) && t.length)
      if (Array.isArray(t[0]) && q(t[0][0]))
        this.ranges = Array.from(t);
      else
        throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(t[0], null, 4)} should be an array and its first element should be an integer, a string index.`);
    else
      this.ranges = [];
  }
  last() {
    return Array.isArray(this.ranges) && this.ranges.length ? this.ranges[this.ranges.length - 1] : null;
  }
};
// ../ranges-merge/dist/ranges-merge.esm.js
var d2 = { mergeType: 1, progressFn: null, joinRangesThatTouchEdges: true };
function b(i, r2) {
  function l2(e) {
    return !!e && typeof e == "object" && !Array.isArray(e);
  }
  if (!Array.isArray(i) || !i.length)
    return null;
  let n;
  if (r2)
    if (l2(r2)) {
      if (n = { ...d2, ...r2 }, n.progressFn && l2(n.progressFn) && !Object.keys(n.progressFn).length)
        n.progressFn = null;
      else if (n.progressFn && typeof n.progressFn != "function")
        throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn, null, 4)}`);
      if (![1, 2, "1", "2"].includes(n.mergeType))
        throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType, null, 4)}`);
      if (typeof n.joinRangesThatTouchEdges != "boolean")
        throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges, null, 4)}`);
    } else
      throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r2, null, 4)} (type ${typeof r2})`);
  else
    n = { ...d2 };
  let g2 = i.filter((e) => Array.isArray(e)).map((e) => [...e]).filter((e) => e[2] !== void 0 || e[0] !== e[1]), s, o, t;
  n.progressFn ? s = g(g2, { progressFn: (e) => {
    t = Math.floor(e / 5), t !== o && (o = t, n.progressFn(t));
  } }) : s = g(g2);
  let a = s.length - 1;
  for (let e = a; e > 0; e--)
    n.progressFn && (t = Math.floor((1 - e / a) * 78) + 21, t !== o && t > o && (o = t, n.progressFn(t))), (s[e][0] <= s[e - 1][0] || !n.joinRangesThatTouchEdges && s[e][0] < s[e - 1][1] || n.joinRangesThatTouchEdges && s[e][0] <= s[e - 1][1]) && (s[e - 1][0] = Math.min(s[e][0], s[e - 1][0]), s[e - 1][1] = Math.max(s[e][1], s[e - 1][1]), s[e][2] !== void 0 && (s[e - 1][0] >= s[e][0] || s[e - 1][1] <= s[e][1]) && s[e - 1][2] !== null && (s[e][2] === null && s[e - 1][2] !== null ? s[e - 1][2] = null : s[e - 1][2] != null ? +n.mergeType == 2 && s[e - 1][0] === s[e][0] ? s[e - 1][2] = s[e][2] : s[e - 1][2] += s[e][2] : s[e - 1][2] = s[e][2]), s.splice(e, 1), e = s.length);
  return s.length ? s : null;
}
// ../../node_modules/tiny-invariant/dist/esm/tiny-invariant.js
var isProduction = process.env.NODE_ENV === "production";
var prefix = "Invariant failed";
function invariant(condition, message) {
  if (condition) {
    return;
  }
  if (isProduction) {
    throw new Error(prefix);
  }
  var provided = typeof message === "function" ? message() : message;
  var value = provided ? "".concat(prefix, ": ").concat(provided) : prefix;
  throw new Error(value);
}
// ../ranges-apply/dist/ranges-apply.esm.js
function _(s, n, r2) {
  let t = 0, p2 = 0;
  if (arguments.length === 0)
    throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");
  if (typeof s != "string")
    throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof s}, equal to: ${JSON.stringify(s, null, 4)}`);
  if (n && !Array.isArray(n))
    throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n, null, 4)}`);
  if (r2 && typeof r2 != "function")
    throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof r2}, equal to: ${JSON.stringify(r2, null, 4)}`);
  if (!n?.filter((e) => e).length)
    return s;
  let i;
  Array.isArray(n) && Number.isInteger(n[0]) && Number.isInteger(n[1]) ? i = [Array.from(n)] : i = Array.from(n);
  let f2 = i.length, c = 0;
  i.filter((e) => e).forEach((e, a) => {
    if (r2 && (t = Math.floor(c / f2 * 10), t !== p2 && (p2 = t, r2(t))), !Array.isArray(e))
      throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${a}th element not an array: ${JSON.stringify(e, null, 4)}, which is ${typeof e}`);
    if (!Number.isInteger(e[0])) {
      if (!Number.isInteger(+e[0]) || +e[0] < 0)
        throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${a}th element, array ${JSON.stringify(e, null, 0)}. Its first element is not an integer, string index, but ${typeof e[0]}, equal to: ${JSON.stringify(e[0], null, 4)}.`);
      i[a][0] = +i[a][0];
    }
    if (!Number.isInteger(e[1])) {
      if (!Number.isInteger(+e[1]) || +e[1] < 0)
        throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${a}th element, array ${JSON.stringify(e, null, 0)}. Its second element is not an integer, string index, but ${typeof e[1]}, equal to: ${JSON.stringify(e[1], null, 4)}.`);
      i[a][1] = +i[a][1];
    }
    c += 1;
  });
  let o = b(i, { progressFn: (e) => {
    r2 && (t = 10 + Math.floor(e / 10), t !== p2 && (p2 = t, r2(t)));
  } });
  invariant(o);
  let u2 = o.length;
  if (u2 > 0) {
    let e = s.slice(o[u2 - 1][1]);
    s = o.reduce((a, $2, l2, y2) => {
      r2 && (t = 20 + Math.floor(l2 / u2 * 80), t !== p2 && (p2 = t, r2(t)));
      let g2 = l2 === 0 ? 0 : y2[l2 - 1][1], d3 = y2[l2][0];
      return `${a}${s.slice(g2, d3)}${y2[l2][2] || ""}`;
    }, ""), s += e;
  }
  return s;
}
// ../js-row-num/dist/js-row-num.esm.js
var R2 = { padStart: 3, overrideRowNum: null, triggerKeywords: ["console.log"], extractedLogContentsWereGiven: false };
function k(t, S) {
  let p2 = Date.now(), f2 = "\\";
  if (typeof t != "string")
    throw new TypeError(`js-row-num: [THROW_ID_01] Input must be string! Currently it's: ${(typeof t).toLowerCase()}, equal to:
${JSON.stringify(t, null, 4)}`);
  if (!t.trim())
    return { log: { timeTakenInMilliseconds: Date.now() - p2 }, result: t, ranges: null };
  function m(n) {
    return /[0-9]/.test(n);
  }
  function D2(n) {
    return /[A-Za-z]/.test(n);
  }
  function w(n) {
    return !!n && typeof n == "object" && !Array.isArray(n);
  }
  let o = { ...R2, ...S };
  if (v(o, "returnRangesOnly"))
    throw new TypeError(`js-row-num: [THROW_ID_02] The Optional Options Object's key "returnRangesOnly" has been removed from the API since v.6 release.`);
  (!o.padStart || typeof o.padStart != "number" || typeof o.padStart == "number" && o.padStart < 0) && (o.padStart = 0);
  let g2 = new y(), e, d3 = t.length, r2 = null, u2 = null, a = null, c = 1, $2 = false, s = null;
  for (o.padStart && d3 > 45e3 && (o.padStart = 4), e = 0; e < d3; e++) {
    if (o.overrideRowNum === null && (t[e] === `
` || t[e] === "\r" && t[e + 1] !== `
`) && (c += 1), !o.extractedLogContentsWereGiven && r2 !== null && r2.start < e && r2.type === t[e] && (r2 = null, u2 = null, a = null, s = null, $2 = false), r2 === null && (o.extractedLogContentsWereGiven || u2 && u2 < e && a && a < e) && t[e].trim())
      if (t[e] === '"' || t[e] === "'" || t[e] === "`")
        r2 = { start: e, type: t[e] }, $2 = false;
      else if (o.extractedLogContentsWereGiven && s === null)
        if (m(t[e]))
          s = e;
        else
          break;
      else
        t[e].trim() && t[e] !== "/" && !o.extractedLogContentsWereGiven && (u2 = null, a = null, s = null);
    if (r2 && Number.isInteger(r2.start) && r2.start < e && !$2 && s === null && m(t[e]) && (s = e), Number.isInteger(s) && (!m(t[e]) || !t[e + 1]) && (e > s || !t[e + 1]) && (o.padStart || o.overrideRowNum != null, g2.push(s, m(t[e]) ? e + 1 : e, o.padStart ? String(o.overrideRowNum != null ? o.overrideRowNum : c).padStart(o.padStart, "0") : `${o.overrideRowNum != null ? o.overrideRowNum : c}`), s = null, $2 = true), r2 && Number.isInteger(r2.start) && r2.start < e && !$2 && D2(t[e]) && !(t[e] === "n" && t[e - 1] === f2)) {
      if (t[e - 1] === f2 && t[e] === "u" && t[e + 1] === "0" && t[e + 2] === "0" && t[e + 3] === "1" && (t[e + 4] === "b" || t[e + 5] === "B") && t[e + 5] === "[") {
        let n;
        m(t[e + 6]) ? n = e + 6 : t[e + 6] === "$" && t[e + 7] === "{" && m(t[e + 8]) && (n = e + 8);
        let l2;
        if (n) {
          for (let b2 = n; b2 < d3; b2++)
            if (!m(t[b2])) {
              l2 = b2;
              break;
            }
        }
        let i;
        if (l2 !== void 0 && t[l2] === "m" ? i = l2 : l2 !== void 0 && t[l2] === "}" && t[l2 + 1] === "m" && (i = l2 + 1), !i) {
          $2 = true;
          continue;
        }
        if (t[i + 1] === "$" && t[i + 2] === "{" && t[i + 3] === "`") {
          e = i + 3;
          continue;
        }
      }
      $2 = true;
    }
    if (!a && t[e].trim() && u2 && u2 <= e && (t[e] === "(" ? a = e : (u2 = null, s = null)), w(o) && o.triggerKeywords && Array.isArray(o.triggerKeywords)) {
      let n;
      for (let l2 = 0, i = o.triggerKeywords.length; l2 < i; l2++)
        if (t.startsWith(o.triggerKeywords[l2], e)) {
          n = o.triggerKeywords[l2];
          break;
        }
      if (n) {
        u2 = e + n.length, e = e + n.length - 1;
        continue;
      }
    }
  }
  return r2 = null, u2 = null, a = null, c = 1, $2 = void 0, s = null, c = 1, { log: { timeTakenInMilliseconds: Date.now() - p2 }, result: _(t, g2.current()), ranges: g2.current() };
}
// src/correct-row-num.ts
var create = (context) => {
  return {
    CallExpression(node) {
      if (node.callee && node.callee.type === "MemberExpression" && node.callee.object && node.callee.object.type === "Identifier" && node.callee.object.name === "console" && node.callee.property && node.callee.property.type === "Identifier" && node.callee.property.name === "log" && node.arguments && Array.isArray(node.arguments) && node.arguments.length) {
        node.arguments.forEach((arg) => {
          if (arg.type === "Literal" && typeof arg.raw === "string" && arg.raw !== k(arg.raw, {
            overrideRowNum: arg.loc.start.line,
            extractedLogContentsWereGiven: true
          }).result) {
            context.report({
              node,
              messageId: "correctRowNum",
              fix: (fixerObj) => {
                let { ranges } = k(arg.raw, {
                  overrideRowNum: arg.loc.start.line,
                  extractedLogContentsWereGiven: true
                });
                if (Array.isArray(ranges) && ranges.length) {
                  let offset = arg.start;
                  if (!offset && arg.range && typeof arg.range[0] === "number") {
                    offset = arg.range[0];
                  }
                  let preppedRanges = [
                    offset + ranges[0][0],
                    offset + ranges[0][1]
                  ];
                  return fixerObj.replaceTextRange(preppedRanges, ranges[0][2]);
                }
              }
            });
          } else if (arg.type === "TemplateLiteral" && Array.isArray(arg.quasis) && arg.quasis.length && typeof arg.quasis[0] === "object" && arg.quasis[0].value?.raw && arg.quasis[0].value.raw !== k(arg.quasis[0].value.raw, {
            overrideRowNum: arg.loc.start.line,
            extractedLogContentsWereGiven: true
          }).result) {
            context.report({
              node,
              messageId: "correctRowNum",
              fix: (fixerObj) => {
                let { ranges } = k(arg.quasis[0].value.raw, {
                  overrideRowNum: arg.loc.start.line,
                  extractedLogContentsWereGiven: true
                });
                if (ranges) {
                  let offset = arg.quasis[0].range[0] + 1;
                  if (!offset && arg.range && typeof arg.range[0] === "number") {
                    offset = arg.quasis[0].start + 1;
                  }
                  let preppedRanges = [
                    offset + ranges[0][0],
                    offset + ranges[0][1]
                  ];
                  return fixerObj.replaceTextRange(preppedRanges, ranges[0][2]);
                }
              }
            });
          }
        });
      }
    }
  };
};
var correctRowNum = {
  create,
  meta: {
    // docs: {
    //   url: getDocumentationUrl(__filename),
    // },
    type: "suggestion",
    messages: {
      correctRowNum: "Update the row number."
    },
    fixable: "code"
    // or "code" or "whitespace"
  }
};
// src/main.ts
var main_default = {
  configs: {
    recommended: {
      plugins: ["row-num"],
      rules: {
        "no-console": "off",
        "row-num/correct-row-num": "error"
      }
    }
  },
  rules: {
    "correct-row-num": correctRowNum
  }
};
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.6.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name js-row-num
 * @fileoverview Update all row numbers in all console.logs in JS code
 * @version 7.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/js-row-num/}
 */

module.exports = main_default;
